declare module 'lincd-github' {
	
}

declare module 'lincd-github/lib/ontologies/github' {
	/// <reference types="lincd" />
	import { NamedNode } from 'lincd/lib/models';
	export var loadData: () => Promise<import("lincd-jsonld/lib/utils/JSONLD").JSONLDParseResult>;
	export var ns: (term: any) => NamedNode;
	export var _self: NamedNode;
	export var Repository: NamedNode;
	export var User: NamedNode;
	export var contributor: NamedNode;
	export var collaborator: NamedNode;
	export var login: NamedNode;
	export var name: NamedNode;
	export var avatar: NamedNode;
	export const github: {
	    Repository: NamedNode;
	    login: NamedNode;
	    contributor: NamedNode;
	    collaborator: NamedNode;
	    name: NamedNode;
	    User: NamedNode;
	    avatar: NamedNode;
	};
}

declare module 'lincd-github/lib/package' {
	export const linkedComponent: <ShapeType extends import("lincd/lib/shapes/Shape").Shape, P = {}>(shapeClass: typeof import("lincd/lib/shapes/Shape").Shape, functionalComponent?: import("lincd/lib/interfaces/Component").FunctionalComponent<P, ShapeType>) => import("lincd/lib/interfaces/Component").FunctionalComponent<Omit<Omit<P, "source">, "sourceShape"> & import("lincd/lib/interfaces/Component").LinkedComponentProps<ShapeType>, ShapeType>, linkedShape: <T extends typeof import("lincd/lib/shapes/Shape").Shape>(constructor: T) => T, linkedUtil: (constructor: any) => any, linkedOntology: (allFileExports: any, nameSpace: (term: string) => import("lincd/lib/models").NamedNode, suggestedPrefixAndFileName: string, loadDataFunction?: () => Promise<any>, dataSource?: string) => void, registerPackageExport: (exportedObject: any) => void, packageExports: any;
}

declare module 'lincd-github/lib/shapes/GithubRepository' {
	/// <reference types="lincd" />
	import { Shape } from 'lincd/lib/shapes/Shape';
	import { NamedNode } from 'lincd/lib/models';
	export class GithubRepository extends Shape {
	    /**
	     * indicates that instances of this shape need to have this rdf.type
	     */
	    static targetClass: NamedNode;
	    /**
	     * instances of this shape need to have exactly one value defined for the given property
	     */
	    get contributors(): import("lincd/lib/collections/PropertySet").PropertySet;
	    /**
	     * instances of this shape need to have exactly one value defined for the given property
	     */
	    get collaborators(): import("lincd/lib/collections/PropertySet").PropertySet;
	}
}

declare module 'lincd-github/lib/shapes/GithubUser' {
	/// <reference types="lincd" />
	import { NamedNode } from 'lincd/lib/models';
	import { UserAccount } from 'lincd-sioc/lib/shapes/UserAccount';
	export class GithubUser extends UserAccount {
	    static targetClass: NamedNode;
	}
}

declare module 'lincd-github/lib/components/GitRepositoryContributors' {
	/// <reference types="lincd" />
	import { GithubRepository } from "lincd-github/lib/shapes/GithubRepository";
	export const GitRepositoryContributors: import("lincd/lib/interfaces/Component").FunctionalComponent<Omit<Omit<{
	    accessToken: string;
	}, "source">, "sourceShape"> & import("lincd/lib/interfaces/Component").LinkedComponentProps<GithubRepository>, GithubRepository>;
}

declare module 'lincd-github/lib/components/GitRepositoryCollaborators' {
	/// <reference types="lincd" />
	import { GithubRepository } from "lincd-github/lib/shapes/GithubRepository";
	export const GitRepositoryCollaborators: import("lincd/lib/interfaces/Component").FunctionalComponent<Omit<Omit<{
	    accessToken: string;
	}, "source">, "sourceShape"> & import("lincd/lib/interfaces/Component").LinkedComponentProps<GithubRepository>, GithubRepository>;
}

declare module 'lincd-github/lib/hooks/git-graphql' {
	/// <reference types="lincd" />
	export function fetchGitGraph(query: any, token: any): Promise<import("lincd/lib/collections/NodeSet").NodeSet<import("lincd/lib/models").Node>>;
}

