"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitRepositoryCollaborators = void 0;
const package_1 = require("../package");
const GithubRepository_1 = require("../shapes/GithubRepository");
const react_1 = __importStar(require("react"));
const schema_1 = require("lincd-schema/lib/ontologies/schema");
const git_graphql_1 = require("../hooks/git-graphql");
const UserAvatar_1 = require("lincd-sioc/lib/components/UserAvatar");
const MAX_NUM_THUMBS = 7;
//nameless functional component with named export.
//export const GitRepositoryCollaborators:FunctionalComponent<{accessToken:string},GithubRepository> = linkedComponent(GithubRepository, ({source,accessToken}) => {
//named functional component with named export.
exports.GitRepositoryCollaborators = (0, package_1.linkedComponent)(GithubRepository_1.GithubRepository, function GitRepositoryCollaborators({ source, accessToken }) {
    let repository = new GithubRepository_1.GithubRepository(source);
    // let collaborators = repository.collaborators;
    const [collaborators, setCollaborators] = (0, react_1.useState)();
    let numLeft, selection;
    if (collaborators) {
        numLeft = collaborators.size - MAX_NUM_THUMBS;
        selection = [...collaborators].slice(0, MAX_NUM_THUMBS);
    }
    //https://github.com/Semantu/lincd.org
    let parts = source ? source.node.value.split('/') : [];
    let repoName = 'lincd';
    let repoOwner = 'semantu';
    (0, react_1.useEffect)(() => {
        (0, git_graphql_1.fetchGitGraph)(`
      query { 
        repository(owner:"${repoOwner}",name:"${repoName}"){
          url 
          collaborators {
            nodes {
              name
              avatarUrl
              login
              resourcePath
            }
          }
        }
      }`, accessToken).then((repositories) => {
            let repositoryResultNode = repositories.first();
            if (repositoryResultNode) {
                let repositoryResult = new GithubRepository_1.GithubRepository(repositoryResultNode);
                console.log(repositoryResultNode === repository.node);
                setCollaborators(repositoryResult.collaborators);
            }
        });
    }, [source]);
    let userClicked = function (collaborator) {
        collaborator.hasProperty(schema_1.schema.url) &&
            window.open('https://github.com/' + collaborator.getValue(schema_1.schema.url), '_blank');
    };
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("p", null,
            react_1.default.createElement("span", { className: "text-grey text-sm" }, "Collaborators"),
            ' ',
            react_1.default.createElement("span", { className: "text-white text-md ml-1" }, collaborators && collaborators.size)),
        selection && (react_1.default.createElement("div", { className: "mt-2" },
            selection.map((collaborator) => {
                return (react_1.default.createElement(UserAvatar_1.UserAvatar, { of: collaborator, key: collaborator.toString(), onClick: () => userClicked(collaborator) }));
            }),
            numLeft > 0 && react_1.default.createElement("span", { className: "text-grey more" },
                "+",
                numLeft,
                " more")))));
});
//# sourceMappingURL=GitRepositoryCollaborators.js.map