"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GitRepositoryContributors = void 0;
const package_1 = require("../package");
const GithubRepository_1 = require("../shapes/GithubRepository");
const react_1 = __importStar(require("react"));
const models_1 = require("lincd/lib/models");
const UserAvatar_1 = require("lincd-sioc/lib/components/UserAvatar");
const UserAccount_1 = require("lincd-sioc/lib/shapes/UserAccount");
const MAX_NUM_THUMBS = 7;
exports.GitRepositoryContributors = (0, package_1.linkedComponent)(GithubRepository_1.GithubRepository, function GitRepositoryContributors({ source, accessToken }) {
    // let repository = new GithubRepository(source);
    // let contributors = repository.contributors;
    const [contributors, setContributors] = (0, react_1.useState)();
    let numLeft, selection;
    if (contributors) {
        numLeft = contributors.length - MAX_NUM_THUMBS;
        selection = [...contributors].slice(0, MAX_NUM_THUMBS);
    }
    //https://github.com/Semantu/lincd.org
    let parts = source.namedNode.uri.match(/https:\/\/github.com\/([\w.-_~]+)\/([\w.-_~]+)/);
    let repoOwner = parts[1]; //'lincd';
    let repoName = parts[2].replace('.git', ''); //'semantu';
    (0, react_1.useEffect)(() => {
        //accessToken
        fetch(`https://api.github.com/repos/${repoOwner}/${repoName}/contributors`, {
            method: 'GET',
            headers: {
                Authorization: 'bearer ' + accessToken,
            },
        })
            .then((result) => result.json())
            .then((contributorsArr) => {
            if (!Array.isArray(contributorsArr)) {
                return;
            }
            contributorsArr.sort((c1, c2) => (c1.contributions > c1.contributions ? -1 : 1));
            // avatar_url: "https://avatars.githubusercontent.com/u/341567?v=4"
            // contributions: 1
            // html_url: "https://github.com/flyon"
            // login: "flyon"
            let contributors = contributorsArr.map((contributorObj) => {
                // let user = new Person();
                // user.name = contributorObj.
                // contributor.accountOf = user;
                let contributor = new UserAccount_1.UserAccount(models_1.NamedNode.getOrCreate(contributorObj.html_url));
                contributor.name = contributorObj.login;
                contributor.avatar = contributorObj.avatar_url;
                return contributor;
            });
            setContributors(contributors);
        });
    }, [source]);
    let userClicked = function (collaborator) {
        window.open(collaborator.namedNode.uri, '_blank');
    };
    return (react_1.default.createElement("div", null,
        contributors && (react_1.default.createElement("p", null,
            react_1.default.createElement("span", { className: "text-grey text-sm" }, "Contributors"),
            ' ',
            react_1.default.createElement("span", { className: "text-white text-md ml-1" }, contributors.length))),
        selection && (react_1.default.createElement("div", { className: "mt-2" },
            selection.map((collaborator) => {
                return (react_1.default.createElement(UserAvatar_1.UserAvatar, { key: collaborator.toString(), of: collaborator.node, onClick: () => userClicked(collaborator) }));
            }),
            numLeft > 0 && react_1.default.createElement("span", { className: "text-grey more" },
                "+",
                numLeft,
                " more")))));
});
//# sourceMappingURL=GitRepositoryContributors.js.map