"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fetchGitGraph = void 0;
const Schema_1 = require("lincd-graphql/lib/shapes/Schema");
const JSONLD_1 = require("lincd-jsonld/lib/utils/JSONLD");
const mapping = __importStar(require("../data/github.graphql.json"));
const rdf_1 = require("lincd/lib/ontologies/rdf");
let schemaPromise = JSONLD_1.JSONLD.parse(mapping).then((res) => {
    let schemaNode = res.quads.getSubjects().find((subject) => subject.has(rdf_1.rdf.type, Schema_1.Schema.targetClass));
    // console.log(schemaNode);
    return Schema_1.Schema.getOf(schemaNode);
});
function fetchGitGraph(query, token) {
    return schemaPromise.then((schema) => {
        return schema
            .query(query, {
            headers: {
                Authorization: 'bearer ' + token,
            },
        })
            .then((resultNodes) => {
            return resultNodes;
        });
        /*return fetch('https://api.github.com/graphql',{
          method:"POST",
          headers:{
            "Authorization": "bearer "+token
          },
          body:JSON.stringify({query:query})
        }).then(res => {
          return res.json()
        }).then(data => {
          console.log(data);
        }).catch(err => {
          console.warn("Error during github graphql request: ",err);
        })*/
    });
}
exports.fetchGitGraph = fetchGitGraph;
//# sourceMappingURL=git-graphql.js.map