"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GithubRepository = void 0;
const Shape_1 = require("lincd/lib/shapes/Shape");
const package_1 = require("../package");
const ShapeDecorators_1 = require("lincd/lib/utils/ShapeDecorators");
const github_1 = require("../ontologies/github");
let GithubRepository = class GithubRepository extends Shape_1.Shape {
    /**
     * instances of this shape need to have exactly one value defined for the given property
     */
    get contributors() {
        return this.getAll(github_1.github.contributor);
    }
    /**
     * instances of this shape need to have exactly one value defined for the given property
     */
    get collaborators() {
        return this.getAll(github_1.github.collaborator);
    }
};
/**
 * indicates that instances of this shape need to have this rdf.type
 */
GithubRepository.targetClass = github_1.github.Repository;
__decorate([
    (0, ShapeDecorators_1.literalProperty)({
        path: github_1.github.contributor,
    })
], GithubRepository.prototype, "contributors", null);
__decorate([
    (0, ShapeDecorators_1.literalProperty)({
        path: github_1.github.collaborator,
    })
], GithubRepository.prototype, "collaborators", null);
GithubRepository = __decorate([
    package_1.linkedShape
], GithubRepository);
exports.GithubRepository = GithubRepository;
//# sourceMappingURL=GithubRepository.js.map