import {NamedNode} from 'lincd/lib/models';
import {JSONLD} from 'lincd-jsonld/lib/utils/JSONLD';
import {createNameSpace} from 'lincd/lib/utils/NameSpace';
import {linkedOntology} from '../package';

import * as _this from './github';

export var loadData = () => {
  return import('../data/github.json').then((data) => JSONLD.parse(data));
};
export var ns = createNameSpace('http://lincd.org/ont/github/');

//It's recommended to export a NamedNode for the ontology itself as well
export var _self: NamedNode = ns('');

export var Repository: NamedNode = ns('Repository');
export var User: NamedNode = ns('User');
export var contributor: NamedNode = ns('contributor');
export var collaborator: NamedNode = ns('collaborator');
export var login: NamedNode = ns('login');
export var name: NamedNode = ns('name');
export var avatar: NamedNode = ns('avatar');

export const github = {
  Repository,
  login,
  contributor,
  collaborator,
  name,
  User,
  avatar,
};

linkedOntology(_this, ns, 'github', loadData, '../data/github.json');
